--[[

TODO: DONE 1. Fix the mod so that it detects the status of the nodes on entry into a AB already in progress.
      	   2. Redo the code to detect how many players (of your side) are near a node.  Test the code to see if
	      Blizzard fixed the problems from before.
      DONE 3. Fix the mod so that its position is saved.
      DONE 4. Save the lowprofile state, so if the player puts it in this state, it will remain in this state until
	      they disable it.
      DONE 5. Clean up the look of the mod (especially the timer windows).
      DONE 6. Add in an optional compact lowprofile mode.
     	   7. Add in the ability to bind the node buttons to keys.
      DONE 8. Add in a popup window that allows the user to quickly enter the number
              of enemies incoming (on shift+click).
      DONE 9. Add in a popup window that features user configurable statements. Node name can be inserted.
	   
]]


ABHelperOptions = {};

--LOCALIZE THIS
local ABHNodeStatus= {TRANSLATION_FARM, TRANSLATION_GOLDMINE, TRANSLATION_BLACKSMITH, TRANSLATION_LUMBERMILL, TRANSLATION_STABLES};

local FarmTimerValue = -1;
local MillTimerValue = -1;
local BlacksmithTimerValue = -1;
local MineTimerValue = -1;
local StablesTimerValue = -1;

local FarmOldClockTime = 0;
local MillOldClockTime = 0;
local BlacksmithOldClockTime = 0;
local MineOldClockTime = 0;
local StablesOldClockTime = 0;

local ABHCounter = 0;

local ABHelper_HideStatus = nil;

local ALLIANCE_CONTROLS = -1;
local ALLIANCE_CONTESTED = -2;
local HORDE_CONTROLS = 1;
local HORDE_CONTESTED = 2;
local UNCONTESTED = 0;

local ABH_BGStatus = nil;
local ABH_BGName = nil;

local CurrentButton = nil;

local ABH_Popup_Counter = 0;
local ABH_UserStatementPopup_Counter = 0;

ABH_IsInWindow = nil;
ABH_IsInUserWindow = nil;

ABH_DebugMode = nil;
ABH_InParty = 1;
ABH_RaidResetCounter = 0;


lower = string.lower;

function ABH_GetPosition(xp, yp)

	if ( xp == nil and yp == nil) then
		xp = ABHelperFrame:GetLeft();
		yp = ABHelperFrame:GetTop();
	end

	ABHelperOptions["Xpos"] = xp
	ABHelperOptions["Ypos"] = yp
end


function ABH_SetPosition()

	if ( ABHelperOptions["Xpos"] ~= nil and ABHelperOptions["Ypos"] ~= nil ) then
		
		ABHelperFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ABHelperOptions["Xpos"], ABHelperOptions["Ypos"] - GetScreenHeight());
		ABHelperFrameHorizontal:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ABHelperOptions["Xpos"], ABHelperOptions["Ypos"] - GetScreenHeight());
	end
end


function ABHDEBUG_GetPosition()
	local xp = ABHelperFrame:GetLeft();
	local yp = ABHelperFrame:GetTop();
	--DEFAULT_CHAT_FRAME:AddMessage("Saved: "..ABHelperOptions["Xpos"]..", "..ABHelperOptions["Ypos"]);
	--DEFAULT_CHAT_FRAME:AddMessage("Actual: "..xp..", "..yp);
end


function ABH_ResetPosition()
	ABHelperFrame:SetPoint("TOPLEFT", 100, -240);
	ABHelperFrameHorizontal:SetPoint("TOPLEFT", 100, -240);
	ABH_GetPosition();
end


function ABH_Vertical_Mode()
	ABHelperFrameHorizontal:Hide();
	ABHelperFrame:Show();
end


function ABH_Horizontal_Mode()
	ABHelperOptions["LowProfile"] = 2;
	ABHelperFrameHorizontal:Show();
	ABHelperFrame:Hide();
	ABH_SetPosition();
end


function ABH_Reset_Mod()

	ABH_SetText("ABH_MillText", 1, 1, 1);	
	ABH_SetText("ABH_MineText", 1, 1, 1);	
	ABH_SetText("ABH_FarmText", 1, 1, 1);	
	ABH_SetText("ABH_BlacksmithText", 1, 1, 1);	
	ABH_SetText("ABH_StablesText", 1, 1, 1);

--LOCALIZE THIS
	ABHNodeStatus[TRANSLATION_LUMBERMILL] = 0;
	ABHNodeStatus[TRANSLATION_GOLDMINE] = 0;
	ABHNodeStatus[TRANSLATION_FARM] = 0;
	ABHNodeStatus[TRANSLATION_BLACKSMITH] = 0;
	ABHNodeStatus[TRANSLATION_STABLES] = 0;
	
	FarmOldClockTime = 0;
	MillOldClockTime = 0;
	BlacksmithOldClockTime = 0;
	MineOldClockTime = 0;
	StablesOldClockTime = 0;

	FarmTimerValue = -1;
	MillTimerValue = -1;
	BlacksmithTimerValue = -1;
	MineTimerValue = -1;
	StablesTimerValue = -1;

	getglobal("FarmIcon1"):SetTexCoord(0.875, 1, 0.375, 0.5);
	getglobal("MillIcon1"):SetTexCoord(0.625, 0.75, 0.25, 0.375);
	getglobal("BlacksmithIcon1"):SetTexCoord(0.25, 0.375, 0.375, 0.5);
	getglobal("MineIcon1"):SetTexCoord(0, 0.125, 0.25, 0.375);
	getglobal("StablesIcon1"):SetTexCoord(0.5, 0.625, 0.5, 0.625);

	getglobal("FarmTimerText"):SetTextColor(1, 1, 0);
	getglobal("MillTimerText"):SetTextColor(1, 1, 0);
	getglobal("BlacksmithTimerText"):SetTextColor(1, 1, 0);
	getglobal("MineTimerText"):SetTextColor(1, 1, 0);
	getglobal("StablesTimerText"):SetTextColor(1, 1, 0);

	getglobal("StablesTimerFrame"):Hide();
	getglobal("MineTimerFrame"):Hide();
	getglobal("FarmTimerFrame"):Hide();
	getglobal("MillTimerFrame"):Hide();
	getglobal("BlacksmithTimerFrame"):Hide();

	ABH_SetText("ABH_MillText2", 1, 1, 1);	
	ABH_SetText("ABH_MineText2", 1, 1, 1);	
	ABH_SetText("ABH_FarmText2", 1, 1, 1);	
	ABH_SetText("ABH_BlacksmithText2", 1, 1, 1);	
	ABH_SetText("ABH_StablesText2", 1, 1, 1);

	getglobal("FarmIcon1_2"):SetTexCoord(0.875, 1, 0.375, 0.5);
	getglobal("MillIcon1_2"):SetTexCoord(0.625, 0.75, 0.25, 0.375);
	getglobal("BlacksmithIcon1_2"):SetTexCoord(0.25, 0.375, 0.375, 0.5);
	getglobal("MineIcon1_2"):SetTexCoord(0, 0.125, 0.25, 0.375);
	getglobal("StablesIcon1_2"):SetTexCoord(0.5, 0.625, 0.5, 0.625);

	getglobal("FarmTimerText2"):SetTextColor(1, 1, 0);
	getglobal("MillTimerText2"):SetTextColor(1, 1, 0);
	getglobal("BlacksmithTimerText2"):SetTextColor(1, 1, 0);
	getglobal("MineTimerText2"):SetTextColor(1, 1, 0);
	getglobal("StablesTimerText2"):SetTextColor(1, 1, 0);

	getglobal("StablesTimerFrame2"):Hide();
	getglobal("MineTimerFrame2"):Hide();
	getglobal("FarmTimerFrame2"):Hide();
	getglobal("MillTimerFrame2"):Hide();
	getglobal("BlacksmithTimerFrame2"):Hide();
end


function ABHToggle()

	if (ABHelperFrame:IsVisible()) then
		ABHelperFrame:Hide();
	else
		
		 ABHelperFrame:Show();
	end
end


function ABH_OnLoad()
	this:RegisterEvent("CHAT_MSG_WHISPER");
	--this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("WORLD_MAP_UPDATE");

	--Tie into the slash command system.
	SlashCmdList["ABHelper"] = ABHelper_SlashHandler;
		SLASH_ABHelper1 = "/abHelper";
		SLASH_ABHelper2 = "/abh";

	ABH_SetPosition();

	getglobal("ABH_FarmText"):SetText(TRANSLATION_FARM);
	getglobal("ABH_MillText"):SetText(TRANSLATION_LUMBERMILL);
	getglobal("ABH_BlacksmithText"):SetText(TRANSLATION_BLACKSMITH);
	getglobal("ABH_MineText"):SetText(TRANSLATION_GOLDMINE);
	getglobal("ABH_StablesText"):SetText(TRANSLATION_STABLES);

	--getglobal("ABH_FarmText2"):SetText(TRANSLATION_FARM);
	--getglobal("ABH_MillText2"):SetText(TRANSLATION_LUMBERMILL);
	--getglobal("ABH_BlacksmithText2"):SetText(TRANSLATION_BLACKSMITH);
	--getglobal("ABH_MineText2"):SetText(TRANSLATION_GOLDMINE);
	--getglobal("ABH_StablesText2"):SetText(TRANSLATION_STABLES);

--LOCALIZE THIS
	DEFAULT_CHAT_FRAME:AddMessage("Arathi Basin Helper by Necrophob (www.totaliterritory.com): type /abh or /abhelper for help.");
end


function SetTimerColor(node)
	
	if(node ~= nil) then
		getglobal(node.."TimerText"):SetTextColor(0, 1, 0);
	end

	if(node ~= nil) then
		getglobal(node.."TimerText2"):SetTextColor(0, 1, 0);
	end

end


function ABH_PulseButton(node)

	local pulsetime = 2;
	local pulseperiod = 0.2;

	if ( node == "farm" ) then
		SetButtonPulse(ABHButton1, pulsetime, pulseperiod);
		SetButtonPulse(ABHButton1_2, pulsetime, pulseperiod);
	elseif ( node == "mill" ) then
		SetButtonPulse(ABHButton2, pulsetime, pulseperiod);
		SetButtonPulse(ABHButton2_2, pulsetime, pulseperiod);
	elseif ( node == "blacksmith" ) then
		SetButtonPulse(ABHButton3, pulsetime, pulseperiod);
		SetButtonPulse(ABHButton3_2, pulsetime, pulseperiod);
	elseif ( node == "mine" ) then
		SetButtonPulse(ABHButton4, pulsetime, pulseperiod);
		SetButtonPulse(ABHButton4_2, pulsetime, pulseperiod);
	elseif ( node == "stables" ) then
		SetButtonPulse(ABHButton5, pulsetime, pulseperiod);
		SetButtonPulse(ABHButton5_2, pulsetime, pulseperiod);
	end
end


function ABH_OnEvent()
	local i;

	if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") then
	
		--DEFAULT_CHAT_FRAME:AddMessage("Event thrown: CHAT_MSG_BG_SYSTEM_ALLIANCE");

		tmparg1 = lower(arg1);
--LOCALIZE THIS
		if(string.find(arg1, TRANSLATION_ASSAULTED) or string.find(arg1, TRANSLATION_CLAIMS)) then
			

			if(string.find(tmparg1, lower(TRANSLATION_MILL))) then
				ABH_PulseButton("mill");
				getglobal("MillTimerFrame"):Show();
				getglobal("MillTimerFrame2"):Show();
				MillTimerValue = 61;
				MillOldClockTime = time();
				SetTimerColor("Mill");

			elseif(string.find(tmparg1, lower(TRANSLATION_MINE))) then
				ABH_PulseButton("mine");
				getglobal("MineTimerFrame"):Show();
				getglobal("MineTimerFrame2"):Show();
				MineTimerValue = 61;
				MineOldClockTime = time();				
				SetTimerColor("Mine");

			elseif(string.find(tmparg1, lower(TRANSLATION_FARM))) then
				ABH_PulseButton("farm");
				getglobal("FarmTimerFrame"):Show();
				getglobal("FarmTimerFrame2"):Show();
				FarmTimerValue = 61;
				FarmOldClockTime = time();
				SetTimerColor("Farm");

			elseif(string.find(tmparg1, lower(TRANSLATION_BLACKSMITH))) then
				ABH_PulseButton("blacksmith");
				getglobal("BlacksmithTimerFrame"):Show();
				getglobal("BlacksmithTimerFrame2"):Show();
				BlacksmithTimerValue = 61;
				BlacksmithOldClockTime = time();
				SetTimerColor("Blacksmith");

			elseif(string.find(tmparg1, lower(TRANSLATION_STABLES))) then
				ABH_PulseButton("stables");
				getglobal("StablesTimerFrame"):Show();
				getglobal("StablesTimerFrame2"):Show();
				StablesTimerValue = 61;
				StablesOldClockTime = time();
				SetTimerColor("Stables");
			end
--LOCALIZE THIS
		elseif(string.find(tmparg1, TRANSLATION_TAKEN) or string.find(tmparg1, TRANSLATION_DEFENDED)) then
			
			if(string.find(tmparg1, lower(TRANSLATION_MILL))) then
				ABH_PulseButton("mill");
				MillTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_MINE))) then
				ABH_PulseButton("mine");
				MineTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_FARM))) then
				ABH_PulseButton("farm");
				FarmTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_BLACKSMITH))) then
				ABH_PulseButton("blacksmith");
				BlacksmithTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_STABLES))) then
				ABH_PulseButton("stables");
				StablesTimerValue = 0;
			end
		end

	elseif(event == "CHAT_MSG_BG_SYSTEM_HORDE") then
		
		--DEFAULT_CHAT_FRAME:AddMessage("Event thrown: CHAT_MSG_BG_SYSTEM_HORDE");

		tmparg1 = lower(arg1);
--LOCALIZE THIS	
		if(string.find(tmparg1, TRANSLATION_ASSAULTED) or string.find(tmparg1, TRANSLATION_CLAIMS)) then
			
			if(string.find(tmparg1, lower(TRANSLATION_MILL))) then
				ABH_PulseButton("mill");
				getglobal("MillTimerFrame"):Show();
				getglobal("MillTimerFrame2"):Show();
				MillTimerValue = 61;
				MillOldClockTime = time();
				SetTimerColor("Mill");

			elseif(string.find(tmparg1, lower(TRANSLATION_MINE))) then
				ABH_PulseButton("mine");
				getglobal("MineTimerFrame"):Show();	
				getglobal("MineTimerFrame2"):Show();
				MineTimerValue = 61;
				MineOldClockTime = time();
				SetTimerColor("Mine");

			elseif(string.find(tmparg1, lower(TRANSLATION_FARM))) then
				ABH_PulseButton("farm");
				getglobal("FarmTimerFrame"):Show();
				getglobal("FarmTimerFrame2"):Show();
				FarmTimerValue = 61;
				FarmOldClockTime = time();
				SetTimerColor("Farm");

			elseif(string.find(tmparg1, lower(TRANSLATION_BLACKSMITH))) then
				ABH_PulseButton("blacksmith");
				getglobal("BlacksmithTimerFrame"):Show();
				getglobal("BlacksmithTimerFrame2"):Show();
				BlacksmithTimerValue = 61;
				BlacksmithOldClockTime = time();
				SetTimerColor("Blacksmith");

			elseif(string.find(tmparg1, lower(TRANSLATION_STABLES))) then	
				ABH_PulseButton("stables");
				getglobal("StablesTimerFrame"):Show();
				getglobal("StablesTimerFrame2"):Show();
				StablesTimerValue = 61;
				StablesOldClockTime = time();
				SetTimerColor("Stables");
			end

--LOCALIZE THIS
		elseif(string.find(tmparg1, TRANSLATION_TAKEN) or string.find(tmparg1, TRANSLATION_DEFENDED)) then
			
			if(string.find(tmparg1, lower(TRANSLATION_MILL))) then
				ABH_PulseButton("mill");
				MillTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_MINE))) then
				ABH_PulseButton("mine");
				MineTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_FARM))) then
				ABH_PulseButton("farm");
				FarmTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_BLACKSMITH))) then
				ABH_PulseButton("blacksmith");
				BlacksmithTimerValue = 0;

			elseif(string.find(tmparg1, lower(TRANSLATION_STABLES))) then
				ABH_PulseButton("stables");
				StablesTimerValue = 0;

			end
		
		end
	
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then

		ABH_SetPosition();

		if ( ABHelperOptions["LowProfile"] == nil ) then
			ABHPickNumberPopup:SetParent(ABHelperFrame);
			ABHUserStatementPopup:SetParent(ABHelperFrame);
			ABH_Vertical_Mode();
			ABHelper_Hide(0);
			ABHelperFrame:Hide();
		elseif ( ABHelperOptions["LowProfile"] == 1 ) then
			ABHPickNumberPopup:SetParent(ABHelperFrame);
			ABHUserStatementPopup:SetParent(ABHelperFrame);
			ABH_Vertical_Mode();
			ABHelper_Hide(1);
			ABHelperFrame:Hide();
		elseif ( ABHelperOptions["LowProfile"] == 2 ) then
			ABHPickNumberPopup:SetParent(ABHelperFrameHorizontal);
			ABHUserStatementPopup:SetParent(ABHelperFrameHorizontal);
			ABH_Horizontal_Mode();
			ABHelperFrameHorizontal:Hide();
		end


		for i=1, MAX_BATTLEFIELD_QUEUES do
			--DEFAULT_CHAT_FRAME:AddMessage(i);
			ABH_BGStatus, ABH_BGName,_ = GetBattlefieldStatus(i);

			if ( ABH_BGStatus == "active" and ABH_BGName == TRANSLATION_ARATHIBASIN) then
				break;
			end
		end

			--LOCALIZE THIS
			if ( ABH_BGStatus == "active" and ABH_BGName == TRANSLATION_ARATHIBASIN) then

				--DEFAULT_CHAT_FRAME:AddMessage("DEBUGLEVEL1");
				ToggleWorldMap();
				ToggleWorldMap();
				ABH_Reset_Mod();
				ABH_SetEntryNodeStatus();

				if(ABHelperOptions["Disabled"] == nil) then
					ABH_ShowHelper();
				end
			else
				ABH_Reset_Mod();
				ABHelperFrame:Hide();
				ABHelperFrameHorizontal:Hide();
			end
		

	elseif( event == "VARIABLES_LOADED") then

		--DEFAULT_CHAT_FRAME:AddMessage("Event thrown: VARIABLES_LOADED");

		ABH_SetPosition();

		getglobal("FarmTimerFrame"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("FarmTimerFrame"):SetBackdropBorderColor(1, 1, 1, 1);
		getglobal("MillTimerFrame"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("MillTimerFrame"):SetBackdropBorderColor(1, 1, 1, 1);
		getglobal("BlacksmithTimerFrame"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("BlacksmithTimerFrame"):SetBackdropBorderColor(1, 1, 1, 0.5);
		getglobal("MineTimerFrame"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("MineTimerFrame"):SetBackdropBorderColor(1, 1, 1, 0.5);
		getglobal("StablesTimerFrame"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("StablesTimerFrame"):SetBackdropBorderColor(1, 1, 1, 0.5);
		ABH_ShowOptionButtons(0);

		getglobal("FarmTimerFrame2"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("FarmTimerFrame2"):SetBackdropBorderColor(1, 1, 1, 1);
		getglobal("MillTimerFrame2"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("MillTimerFrame2"):SetBackdropBorderColor(1, 1, 1, 1);
		getglobal("BlacksmithTimerFrame2"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("BlacksmithTimerFrame2"):SetBackdropBorderColor(1, 1, 1, 0.5);
		getglobal("MineTimerFrame2"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("MineTimerFrame2"):SetBackdropBorderColor(1, 1, 1, 0.5);
		getglobal("StablesTimerFrame2"):SetBackdropColor(0, 0.1, 0.9, 0.25);
		getglobal("StablesTimerFrame2"):SetBackdropBorderColor(1, 1, 1, 0.5);

--LOCALIZE THIS
		if (ABHelperOptions["AutoInviteKeyword"] == nil) then
			ABHelperOptions["AutoInviteKeyword"] = "invite";
		end

--LOCALIZE THIS
		if (ABHelperOptions["AssaultText"] == nil) then
			ABHelperOptions["AssaultText"] = TRANSLATION_DEFAULT_ASSAULT_MSG;
		end

--LOCALIZE THIS
		if (ABHelperOptions["IncomingText"] == nil) then
			ABHelperOptions["IncomingText"] = TRANSLATION_DEFAULT_INCOMING_MSG
		end
		ABH_Reset_Mod();


		if (ABHelperOptions["UserStatements"] == nil) then
			ABHelperOptions["UserStatements"] = {};
		end

		
		if (ABHelperOptions["UserStatements"]["NotFirstTime"] == nil) then
			ABH_ResetPosition();
			ABH_Reset_UserStatements();	
		end
		
		if (ABHelperOptions["UserStatements"]["NotFirstTime"] == nil) then
			ABHelperOptions["UserStatements"]["NotFirstTime"] = 1;
		end

--LOCALIZE THIS
	elseif ( event == "WORLD_MAP_UPDATE" ) then

		if ( ABH_BGStatus == "active" and ABH_BGName == TRANSLATION_ARATHIBASIN) then
			ABH_SetEntryNodeStatus();
		end

	elseif ( event == "CHAT_MSG_WHISPER" ) then
		
		if ( ABHelperOptions["AutoInvite"] ) then

			if ( string.find(arg1, ABHelperOptions["AutoInviteKeyword"]) ) then
				InviteByName(arg2);
			end
		end
	end

end


function ABH_InviteAll()
	local numPlayers = GetNumBattlefieldPositions();
	local i;
	local name = {};

	for i=1,numPlayers do
		_, _, name = GetBattlefieldPosition(i);
		InviteByName( name );
	end
end


--LOCALIZE THIS
function ABH_UserButtonOnEnter(num)
	local node = ABH_UserStatementPopupTitle:GetText();
	local TmpStr = {};

	if ( node == TRANSLATION_FARM ) then
		TmpStr = ABHelperOptions["UserStatements"]["Farm"..num];
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent); 
		GameTooltip:SetText(TmpStr);
	elseif ( node == TRANSLATION_LUMBERMILL ) then
		TmpStr = ABHelperOptions["UserStatements"]["Mill"..num];
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent); 
		GameTooltip:SetText(TmpStr);
	elseif ( node == TRANSLATION_BLACKSMITH ) then
		TmpStr = ABHelperOptions["UserStatements"]["Smith"..num];
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent); 
		GameTooltip:SetText(TmpStr);
	elseif ( node == TRANSLATION_GOLDMINE ) then
		TmpStr = ABHelperOptions["UserStatements"]["Mine"..num];
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent); 
		GameTooltip:SetText(TmpStr);
	elseif ( node == TRANSLATION_STABLES ) then
		TmpStr = ABHelperOptions["UserStatements"]["Stables"..num];
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent); 
		GameTooltip:SetText(TmpStr);
	end
end
				

--LOCALIZE THIS
function ABH_Reset_UserStatements()

	ABHelperOptions["UserStatements"] = {};

	if (ABHelperOptions["UserStatements"]["Farm1"] == nil) then
		ABHelperOptions["UserStatements"]["Farm1"] = "Inc farm, from mines.";
	end

	if (ABHelperOptions["UserStatements"]["Farm2"] == nil) then
		ABHelperOptions["UserStatements"]["Farm2"] = "Inc farm, from mill.";
	end

	if (ABHelperOptions["UserStatements"]["Mill1"] == nil) then
		ABHelperOptions["UserStatements"]["Mill1"] = "Nobody defending mill.";
	end

	if (ABHelperOptions["UserStatements"]["Mill2"] == nil) then
		ABHelperOptions["UserStatements"]["Mill2"] = "Sapped at mill.";
	end

	if (ABHelperOptions["UserStatements"]["Smith1"] == nil) then
		ABHelperOptions["UserStatements"]["Smith1"] = "Inc smith from water!";
	end

	if (ABHelperOptions["UserStatements"]["Smith2"] == nil) then
		ABHelperOptions["UserStatements"]["Smith2"] = "Sapped at smith.";
	end

	if (ABHelperOptions["UserStatements"]["Mine1"] == nil) then
		ABHelperOptions["UserStatements"]["Mine1"] = "Mines undefended.";
	end

	if (ABHelperOptions["UserStatements"]["Mine2"] == nil) then
		ABHelperOptions["UserStatements"]["Mine2"] = "Someone go take the mines.";
	end

	if (ABHelperOptions["UserStatements"]["Stables1"] == nil) then
		ABHelperOptions["UserStatements"]["Stables1"] = "Zerging farm, let's take stables.";
	end

	if (ABHelperOptions["UserStatements"]["Stables2"] == nil) then
		ABHelperOptions["UserStatements"]["Stables2"] = "Get away from stables.";
	end
end


function ABH_PopulatePopUpButtons(name, id)
	--DEFAULT_CHAT_FRAME:AddMessage(getglobal(name):GetText());
	getglobal(name.."Text"):SetText(id);
end


--DEBUG=Fix this stuff, have to get the fonts working again in the user statement panel.
function ABH_Populate_UserStatements(button)
	local i;
	local TmpStr = {};
	local TmpStr2 = {};

	if (  button == TRANSLATION_FARM ) then
		for i=1,8 do
			if ( ABHelperOptions["UserStatements"]["Farm"..i] ~= nil and ABHelperOptions["UserStatements"]["Farm"..i] ~= "") then
				TmpStr = strsub(ABHelperOptions["UserStatements"]["Farm"..i], 1, 14);

				if(strlen(ABHelperOptions["UserStatements"]["Farm"..i]) > 14) then
					TmpStr = TmpStr.."...";
				end
					
				--getglobal("ABHUserStatementButton"..i):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i.."Text"):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i):Show();
			else
				getglobal("ABHUserStatementButton"..i):Hide();
			end
		end
	elseif (  button == TRANSLATION_LUMBERMILL ) then
		for i=1,8 do
			if ( ABHelperOptions["UserStatements"]["Mill"..i] ~= nil and ABHelperOptions["UserStatements"]["Mill"..i] ~= "") then
				TmpStr = strsub(ABHelperOptions["UserStatements"]["Mill"..i], 1, 14);
				
				if(strlen(ABHelperOptions["UserStatements"]["Mill"..i]) > 14) then
					TmpStr = TmpStr.."...";
				end

				--getglobal("ABHUserStatementButton"..i):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i.."Text"):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i):Show();
			else
				getglobal("ABHUserStatementButton"..i):Hide();
			end
		end
	elseif ( button == TRANSLATION_BLACKSMITH ) then
		for i=1,8 do
			if ( ABHelperOptions["UserStatements"]["Smith"..i] ~= nil and ABHelperOptions["UserStatements"]["Smith"..i] ~= "") then
				TmpStr = strsub(ABHelperOptions["UserStatements"]["Smith"..i], 1, 14);

				if(strlen(ABHelperOptions["UserStatements"]["Smith"..i]) > 14) then
					TmpStr = TmpStr.."...";
				end

				--getglobal("ABHUserStatementButton"..i):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i.."Text"):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i):Show();
			else
				getglobal("ABHUserStatementButton"..i):Hide();
			end
		end
	elseif ( button == TRANSLATION_GOLDMINE ) then
		for i=1,8 do
			if ( ABHelperOptions["UserStatements"]["Mine"..i] ~= nil and ABHelperOptions["UserStatements"]["Mine"..i] ~= "") then
				TmpStr = strsub(ABHelperOptions["UserStatements"]["Mine"..i], 1, 14);

				if(strlen(ABHelperOptions["UserStatements"]["Mine"..i]) > 14) then
					TmpStr = TmpStr.."...";
				end

				--getglobal("ABHUserStatementButton"..i):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i.."Text"):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i):Show();
			else
				getglobal("ABHUserStatementButton"..i):Hide();
			end
		end
	elseif ( button == TRANSLATION_STABLES ) then
		for i=1,8 do
			if ( ABHelperOptions["UserStatements"]["Stables"..i] ~= nil and ABHelperOptions["UserStatements"]["Stables"..i] ~= "") then
				TmpStr = strsub(ABHelperOptions["UserStatements"]["Stables"..i], 1, 14);

				if(strlen(ABHelperOptions["UserStatements"]["Stables"..i]) > 14) then
					TmpStr = TmpStr.."...";
				end

				--getglobal("ABHUserStatementButton"..i):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i.."Text"):SetText(TmpStr);
				getglobal("ABHUserStatementButton"..i):Show();
			else
				getglobal("ABHUserStatementButton"..i):Hide();
			end
		end
	end
end


function ABH_ShowHelper()
	if ( ABHelperOptions["LowProfile"] == nil ) then
		ABH_Vertical_Mode();
		ABHelper_Hide(0);
	elseif ( ABHelperOptions["LowProfile"] == 1 ) then
		ABH_Vertical_Mode();
		ABHelper_Hide(1);
	elseif ( ABHelperOptions["LowProfile"] == 2 ) then
		ABH_Horizontal_Mode();
	end
end


function ABH_ShowOptionButtons(val)

	if(val == 0) then
		ABHelperCloseButton:SetAlpha(0);
		ABHelperHideButton:SetAlpha(0);
		ABHelperHelpButton:SetAlpha(0);
		ABHelperConvertRaidButton:SetAlpha(0);

		ABHelperCloseButton2:SetAlpha(0);
		ABHelperHideButton2:SetAlpha(0);
		ABHelperHelpButton2:SetAlpha(0);
		ABHelperConvertRaidButton2:SetAlpha(0);

	elseif (val == 1) then
		ABHelperCloseButton:SetAlpha(1);
		ABHelperHideButton:SetAlpha(1);
		ABHelperHelpButton:SetAlpha(1);
		ABHelperConvertRaidButton:SetAlpha(1);
		
		ABHelperCloseButton2:SetAlpha(1);
		ABHelperHideButton2:SetAlpha(1);
		ABHelperHelpButton2:SetAlpha(1);
		ABHelperConvertRaidButton2:SetAlpha(1);
	end
end


--LOCALIZE THIS
function ABH_SetIcon(node, status)

	if ( node == TRANSLATION_FARM ) then
		if ( status == UNCONTESTED ) then
			ABH_SetText("ABH_FarmText", 1, 1, 1);
			ABH_SetText("ABH_FarmText2", 1, 1, 1);
			ABHNodeStatus[TRANSLATION_FARM] = UNCONTESTED;
			getglobal("FarmIcon1"):SetTexCoord(0.875, 1, 0.375, 0.5);
			getglobal("FarmIcon1_2"):SetTexCoord(0.875, 1, 0.375, 0.5);

		elseif ( status == ALLIANCE_CONTROLS ) then
			ABH_SetText("ABH_FarmText", 0, 0, 1);
			ABH_SetText("ABH_FarmText2", 0, 0, 1);
			ABHNodeStatus[TRANSLATION_FARM] = ALLIANCE_CONTROLS;
			getglobal("FarmIcon1"):SetTexCoord(0.125, 0.25, 0.5, 0.625);
			getglobal("FarmIcon1_2"):SetTexCoord(0.125, 0.25, 0.5, 0.625);

		elseif ( status == HORDE_CONTROLS ) then
			ABH_SetText("ABH_FarmText", 1, 0, 0);
			ABH_SetText("ABH_FarmText2", 1, 0, 0);
			ABHNodeStatus[TRANSLATION_FARM] = HORDE_CONTROLS;
			getglobal("FarmIcon1"):SetTexCoord(0.375, 0.5, 0.5, 0.625);
			getglobal("FarmIcon1_2"):SetTexCoord(0.375, 0.5, 0.5, 0.625);

		elseif ( status == ALLIANCE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_FARM] = ALLIANCE_CONTESTED;
			ABH_SetText("ABH_FarmText", 0, 0, 0.5);
			getglobal("FarmIcon1"):SetTexCoord(0, 0.125, 0.5, 0.625);
			ABH_SetText("ABH_FarmText2", 0, 0, 0.5);
			getglobal("FarmIcon1_2"):SetTexCoord(0, 0.125, 0.5, 0.625);

		elseif ( status == HORDE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_FARM] = HORDE_CONTESTED;
			ABH_SetText("ABH_FarmText", 0.5, 0, 0);
			getglobal("FarmIcon1"):SetTexCoord(0.25, 0.375, 0.5, 0.625);
			ABH_SetText("ABH_FarmText2", 0.5, 0, 0);
			getglobal("FarmIcon1_2"):SetTexCoord(0.25, 0.375, 0.5, 0.625);

		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end

	elseif ( node == TRANSLATION_GOLDMINE ) then
		if ( status == UNCONTESTED ) then
			ABH_SetText("ABH_MineText", 1, 1, 1);
			ABHNodeStatus[TRANSLATION_GOLDMINE] = UNCONTESTED;	
			getglobal("MineIcon1"):SetTexCoord(0, 0.125, 0.25, 0.375);
			ABH_SetText("ABH_MineText2", 1, 1, 1);
			getglobal("MineIcon1_2"):SetTexCoord(0, 0.125, 0.25, 0.375);

		elseif ( status == ALLIANCE_CONTROLS ) then
			ABH_SetText("ABH_MineText", 0, 0, 1);
			ABHNodeStatus[TRANSLATION_GOLDMINE] = -1;
			getglobal("MineIcon1"):SetTexCoord(0.25, 0.375, 0.25, 0.375);

			ABH_SetText("ABH_MineText2", 0, 0, 1);
			getglobal("MineIcon1_2"):SetTexCoord(0.25, 0.375, 0.25, 0.375);
		elseif ( status == HORDE_CONTROLS ) then
			ABH_SetText("ABH_MineText", 1, 0, 0);
			ABHNodeStatus[TRANSLATION_GOLDMINE] = HORDE_CONTROLS;
			getglobal("MineIcon1"):SetTexCoord(0.5, 0.625, 0.25, 0.375);	
			ABH_SetText("ABH_MineText2", 1, 0, 0);
			getglobal("MineIcon1_2"):SetTexCoord(0.5, 0.625, 0.25, 0.375);
		elseif ( status == ALLIANCE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_GOLDMINE] = ALLIANCE_CONTESTED;
			ABH_SetText("ABH_MineText", 0, 0, 0.5);
			getglobal("MineIcon1"):SetTexCoord(0.125, 0.25, 0.25, 0.375);
			ABH_SetText("ABH_MineText2", 0, 0, 0.5);
			getglobal("MineIcon1_2"):SetTexCoord(0.125, 0.25, 0.25, 0.375);
		elseif ( status == HORDE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_GOLDMINE] = HORDE_CONTESTED;
			ABH_SetText("ABH_MineText", 0.5, 0, 0);
			getglobal("MineIcon1"):SetTexCoord(0.375, 0.5, 0.25, 0.375);
			
			ABH_SetText("ABH_MineText2", 0.5, 0, 0);
			getglobal("MineIcon1_2"):SetTexCoord(0.375, 0.5, 0.25, 0.375);
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end
	elseif ( node == TRANSLATION_BLACKSMITH ) then
		if ( status == UNCONTESTED ) then
			ABH_SetText("ABH_BlacksmithText", 1, 1, 1);
			ABHNodeStatus[TRANSLATION_BLACKSMITH] = UNCONTESTED;	
			getglobal("BlacksmithIcon1"):SetTexCoord(0.25, 0.375, 0.375, 0.5);
			ABH_SetText("ABH_BlacksmithText2", 1, 1, 1);	
			getglobal("BlacksmithIcon1_2"):SetTexCoord(0.25, 0.375, 0.375, 0.5);
		elseif ( status == ALLIANCE_CONTROLS ) then
			ABH_SetText("ABH_BlacksmithText", 0, 0, 1);
			ABHNodeStatus[TRANSLATION_BLACKSMITH] = ALLIANCE_CONTROLS;
			getglobal("BlacksmithIcon1"):SetTexCoord(0.5, 0.625, 0.375, 0.5);
			ABH_SetText("ABH_BlacksmithText2", 0, 0, 1);
			getglobal("BlacksmithIcon1_2"):SetTexCoord(0.5, 0.625, 0.375, 0.5);
		elseif ( status == HORDE_CONTROLS ) then
			ABH_SetText("ABH_BlacksmithText", 1, 0, 0);
			ABHNodeStatus[TRANSLATION_BLACKSMITH] = HORDE_CONTROLS;
			getglobal("BlacksmithIcon1"):SetTexCoord(0.75, 0.875, 0.375, 0.5);
			ABH_SetText("ABH_BlacksmithText2", 1, 0, 0);
			getglobal("BlacksmithIcon1_2"):SetTexCoord(0.75, 0.875, 0.375, 0.5);
		elseif ( status == ALLIANCE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_BLACKSMITH] = ALLIANCE_CONTESTED;
			ABH_SetText("ABH_BlacksmithText", 0, 0, 0.5);
			getglobal("BlacksmithIcon1"):SetTexCoord(0.375, 0.5, 0.375, 0.5);
			ABH_SetText("ABH_BlacksmithText2", 0, 0, 0.5);
			getglobal("BlacksmithIcon1_2"):SetTexCoord(0.375, 0.5, 0.375, 0.5);
		elseif ( status == HORDE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_BLACKSMITH] = HORDE_CONTESTED;
			ABH_SetText("ABH_BlacksmithText", 0.5, 0, 0);
			getglobal("BlacksmithIcon1"):SetTexCoord(0.625, 0.75, 0.375, 0.5);
			ABH_SetText("ABH_BlacksmithText2", 0.5, 0, 0);
			getglobal("BlacksmithIcon1_2"):SetTexCoord(0.625, 0.75, 0.375, 0.5);
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end
	elseif ( node == TRANSLATION_LUMBERMILL ) then
		if ( status == UNCONTESTED ) then
			ABH_SetText("ABH_MillText", 1, 1, 1);	
			ABHNodeStatus[TRANSLATION_LUMBERMILL] = UNCONTESTED;
			getglobal("MillIcon1"):SetTexCoord(0.625, 0.75, 0.25, 0.375);
			ABH_SetText("ABH_MillText2", 1, 1, 1);	
			getglobal("MillIcon1_2"):SetTexCoord(0.625, 0.75, 0.25, 0.375);

		elseif ( status == ALLIANCE_CONTROLS ) then
			ABH_SetText("ABH_MillText", 0, 0, 1);
			ABHNodeStatus[TRANSLATION_LUMBERMILL] = ALLIANCE_CONTROLS;
			getglobal("MillIcon1"):SetTexCoord(0.875, 1, 0.25, 0.375);
			ABH_SetText("ABH_MillText2", 0, 0, 1);
			getglobal("MillIcon1_2"):SetTexCoord(0.875, 1, 0.25, 0.375);
		elseif ( status == HORDE_CONTROLS ) then
			ABH_SetText("ABH_MillText", 1, 0, 0);
			ABHNodeStatus[TRANSLATION_LUMBERMILL] = HORDE_CONTROLS;
			getglobal("MillIcon1"):SetTexCoord(0.125, 0.25, 0.375, 0.5);
			ABH_SetText("ABH_MillText2", 1, 0, 0);
			getglobal("MillIcon1_2"):SetTexCoord(0.125, 0.25, 0.375, 0.5);
		elseif ( status == ALLIANCE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_LUMBERMILL] = ALLIANCE_CONTESTED;
			ABH_SetText("ABH_MillText", 0, 0, 0.5);
			getglobal("MillIcon1"):SetTexCoord(0.75, 0.875, 0.25, 0.375);
			ABH_SetText("ABH_MillText2", 0, 0, 0.5);
			getglobal("MillIcon1_2"):SetTexCoord(0.75, 0.875, 0.25, 0.375);
		elseif ( status == HORDE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_LUMBERMILL] = HORDE_CONTESTED;
			ABH_SetText("ABH_MillText", 0.5, 0, 0);
			getglobal("MillIcon1"):SetTexCoord(0, 0.125, 0.375, 0.5);
			ABH_SetText("ABH_MillText2", 0.5, 0, 0);
			getglobal("MillIcon1_2"):SetTexCoord(0, 0.125, 0.375, 0.5);
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");	
		end
	elseif ( node == TRANSLATION_STABLES ) then
		if ( status == UNCONTESTED ) then
			ABH_SetText("ABH_StablesText", 1, 1, 1);
			ABHNodeStatus[TRANSLATION_STABLES] = UNCONTESTED;
			getglobal("StablesIcon1"):SetTexCoord(0.5, 0.625, 0.5, 0.625);
			ABH_SetText("ABH_StablesText2", 1, 1, 1);
			getglobal("StablesIcon1_2"):SetTexCoord(0.5, 0.625, 0.5, 0.625);

		elseif ( status == ALLIANCE_CONTROLS ) then
			ABH_SetText("ABH_StablesText", 0, 0, 1);
			ABHNodeStatus[TRANSLATION_STABLES] = ALLIANCE_CONTROLS;
			getglobal("StablesIcon1"):SetTexCoord(0.75, 0.875, 0.5, 0.625);
			ABH_SetText("ABH_StablesText2", 0, 0, 1);
			getglobal("StablesIcon1_2"):SetTexCoord(0.75, 0.875, 0.5, 0.625);

		elseif ( status == HORDE_CONTROLS ) then
			ABH_SetText("ABH_StablesText", 1, 0, 0);
			ABHNodeStatus[TRANSLATION_STABLES] = HORDE_CONTROLS;
			getglobal("StablesIcon1"):SetTexCoord(0, 0.125, 0.625, 0.75);
			ABH_SetText("ABH_StablesText2", 1, 0, 0);
			getglobal("StablesIcon1_2"):SetTexCoord(0, 0.125, 0.625, 0.75);


		elseif ( status == ALLIANCE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_STABLES] = ALLIANCE_CONTESTED;	
			ABH_SetText("ABH_StablesText", 0, 0, 0.5);
			getglobal("StablesIcon1"):SetTexCoord(0.625, 0.75, 0.5, 0.625);	
			ABH_SetText("ABH_StablesText2", 0, 0, 0.5);
			getglobal("StablesIcon1_2"):SetTexCoord(0.625, 0.75, 0.5, 0.625);

		elseif ( status == HORDE_CONTESTED ) then
			ABHNodeStatus[TRANSLATION_STABLES] = HORDE_CONTESTED;
			ABH_SetText("ABH_StablesText", 0.5, 0, 0);
			getglobal("StablesIcon1"):SetTexCoord(0.875, 1, 0.5, 0.625);
			ABH_SetText("ABH_StablesText2", 0.5, 0, 0);
			getglobal("StablesIcon1_2"):SetTexCoord(0.875, 1, 0.5, 0.625);

		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
	end
end


--LOCALIZE THIS
function ABH_SetEntryNodeStatus()
	local name, description, textID, x, y, i;
	
	for i = 1,5 do
		name, description, textID, x, y = GetMapLandmarkInfo(i);

		if ( description ~= nil) then
			if ( string.find(description, TRANSLATION_ALLIANCE) ) then
				ABH_SetIcon(name, ALLIANCE_CONTROLS)
			elseif ( string.find(description, TRANSLATION_HORDE) ) then
				ABH_SetIcon(name, HORDE_CONTROLS)
			elseif ( string.find(description, TRANSLATION_CONFLICT) ) then
			
				if( textID == 29 or textID == 34 or textID == 19 or textID == 24 or textID == 39) then
					ABH_SetIcon(name, HORDE_CONTESTED)
				elseif( textID == 27 or textID == 32 or textID == 17 or textID == 22 or textID == 37) then
					ABH_SetIcon(name, ALLIANCE_CONTESTED)
				end
			end
		end
	end

end


--LOCALIZE THIS
function ABH_Raid_Warning(node, number)
	local GroupType, GroupSize, RaidSize, ChannelNum;
	local faction;

	GroupSize = GetNumPartyMembers();
	RaidSize = GetNumRaidMembers();

	if ( number == nil) then
		number = "";
	end

	--if(ABHelperOptions["Channel"] == nil) then
	--	if(GroupSize == 0 and RaidSize == 0) then	
	--		GroupType = "CHANNEL";
	--		ChannelNum = 1;
	--	elseif(RaidSize == 0) then
	--		GroupType = "PARTY";
	--		ChannelNum = "player";
	--	else
	--		GroupType = "RAID";
	--		ChannelNum = "player";
	--	end
	--elseif(ABHelperOptions["Channel"] == "general") then
	--	GroupType = "CHANNEL";
	--	ChannelNum = 1;
	--elseif(ABHelperOptions["Channel"] == "party") then
	--	GroupType = "PARTY";
	--	ChannelNum = "player";
	--elseif(ABHelperOptions["Channel"] == "raid") then
	--	GroupType = "RAID";
	--	ChannelNum = "player";
	--end

	GroupType = "BATTLEGROUND";
	ChannelNum = "player";

	if (ABH_DebugMode) then
		GroupType = "WHISPER";
		ChannelNum = UnitName("player");
	end


--LOCALIZE THIS
	faction = UnitFactionGroup("player");

	if(faction == "Horde") then
		if( ABHNodeStatus[node] == ALLIANCE_CONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == ALLIANCE_CONTROLS ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == UNCONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == HORDE_CONTROLS ) then
			SendChatMessage( number.." "..ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == HORDE_CONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum );
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure "..ABHNodeStatus[node]);
		end
		
		--DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Horde");		

	elseif(faction == "Alliance") then
		if( ABHNodeStatus[node] == HORDE_CONTROLS ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == HORDE_CONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == UNCONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == ALLIANCE_CONTESTED ) then
			SendChatMessage( number.." "..ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum );
		elseif( ABHNodeStatus[node] == ALLIANCE_CONTROLS ) then
			SendChatMessage( number.." "..ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum );
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end

		--DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Alliance");	
	end

	
end


function ABH_UserStatement_Send(num)
	local GroupType, GroupSize, RaidSize, ChannelNum;
	local node = ABH_UserStatementPopupTitle:GetText();
	local TmpStr = {};
	GroupSize = GetNumPartyMembers();
	RaidSize = GetNumRaidMembers();

	if(ABHelperOptions["Channel"] == nil) then
		if(GroupSize == 0 and RaidSize == 0) then	
			GroupType = "CHANNEL";
			ChannelNum = 1;
		elseif(RaidSize == 0) then
			GroupType = "PARTY";
			ChannelNum = "player";
		else
			GroupType = "RAID";
			ChannelNum = "player";
		end
	elseif(ABHelperOptions["Channel"] == "general") then
		GroupType = "CHANNEL";
		ChannelNum = 1;
	elseif(ABHelperOptions["Channel"] == "party") then
		GroupType = "PARTY";
		ChannelNum = "player";
	elseif(ABHelperOptions["Channel"] == "raid") then
		GroupType = "RAID";
		ChannelNum = "player";
	end

	if ( node == TRANSLATION_FARM ) then
		TmpStr = ABHelperOptions["UserStatements"]["Farm"..num];
		
	elseif ( node == TRANSLATION_LUMBERMILL ) then
		TmpStr = ABHelperOptions["UserStatements"]["Mill"..num];
		
	elseif ( node == TRANSLATION_BLACKSMITH ) then
		TmpStr = ABHelperOptions["UserStatements"]["Smith"..num];
		
	elseif ( node == TRANSLATION_GOLDMINE ) then
		TmpStr = ABHelperOptions["UserStatements"]["Mine"..num];
		
	elseif ( node == TRANSLATION_STABLES ) then
		TmpStr = ABHelperOptions["UserStatements"]["Stables"..num];
		
	end

	if (TmpStr ~= nil and TmpStr ~= "") then
		SendChatMessage(TmpStr, GroupType, nil, ChannelNum );
	end
	
	ABHUserStatementPopup:Hide();
end


function ABH_DEBUG2(num)
		node = "Farm";
		ABHNodeStatus["Farm"] = num;
		
		GroupType = "WHISPER"
		ChannelNum = "Thronk"

		if(ABHNodeStatus[node] == 1) then
			SendChatMessage(ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum);
		elseif(ABHNodeStatus[node] == 2) then
			SendChatMessage(ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum);
		elseif(ABHNodeStatus[node] == 0) then
			SendChatMessage(ABHelperOptions["AssaultText"].." "..node, GroupType, nil, ChannelNum);
		elseif(ABHNodeStatus[node] == -2) then
			SendChatMessage(ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum);
		elseif(ABHNodeStatus[node] == -1) then
			SendChatMessage(ABHelperOptions["IncomingText"].." "..node, GroupType, nil, ChannelNum);
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG: Failure");
		end
end


function ABH_SetText(node, r, g, b)
	getglobal(node):SetTextColor(r, g, b);
end


function ABHelper_Hide(val)
	
	if (val == 1) then
		ABHelperOptions["LowProfile"] = 1;

		getglobal("ABHBack1"):SetTexture("");
		getglobal("ABHBack2"):SetTexture("");
		getglobal("IconFrame1"):SetTexture("");
		getglobal("IconFrame2"):SetTexture("");
		getglobal("IconFrame3"):SetTexture("");
		getglobal("IconFrame4"):SetTexture("");
		getglobal("IconFrame5"):SetTexture("");
		getglobal("ABHButton1Texture"):SetTexture("");
		getglobal("ABHButton2Texture"):SetTexture("");
		getglobal("ABHButton3Texture"):SetTexture("");
		getglobal("ABHButton4Texture"):SetTexture("");
		getglobal("ABHButton5Texture"):SetTexture("");

		getglobal("ABH_Title"):Hide();
		getglobal("ABHelperHideButton"):SetText("+");
		getglobal("ABHelperFrame"):SetMovable("False");
		--getglobal("ABHelperFrame"):SetHeight(0);
		ABHelper_HideStatus = 1;

	elseif (val == 0) then
		ABHelperOptions["LowProfile"] = nil;

		getglobal("ABHBack1"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\ABBackTop");
		getglobal("ABHBack2"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\ABBackBottom");
		getglobal("IconFrame1"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\IconFrame");
		getglobal("IconFrame2"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\IconFrame");
		getglobal("IconFrame3"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\IconFrame");
		getglobal("IconFrame4"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\IconFrame");
		getglobal("IconFrame5"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\IconFrame");
		getglobal("ABHButton1Texture"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\Button2");
		getglobal("ABHButton2Texture"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\Button2");
		getglobal("ABHButton3Texture"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\Button2");
		getglobal("ABHButton4Texture"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\Button2");
		getglobal("ABHButton5Texture"):SetTexture("Interface\\AddOns\\ABHelper\\Images\\Button2");

		getglobal("ABH_Title"):Show();
		getglobal("ABHelperHideButton"):SetText("-");
		getglobal("ABHelperFrame"):SetMovable("True");
		--getglobal("ABHelperFrame"):SetHeight(192);
		ABHelper_HideStatus = nil;
	end

end


--LOCALIZE THIS
function ABHelper_Help()
	DEFAULT_CHAT_FRAME:AddMessage("Arathi Basin Helper usage:");
	DEFAULT_CHAT_FRAME:AddMessage("/abh on (AB Helper will autodisplay on entry into an AB battleground).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh off (AB Helper will not autodisplay on entry into an AB battleground).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh show (displays the mod, whether you're in AB or not).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh hide (hides the mod).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh incomingmessage <message> (changes the incoming message, ex: /abh incomingmessage Watch out at).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh assaultmessage <message> (changes the assault message, ex: /abh assaultmessage Take the).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh channel <channeltype> (sets the channel to send messages to, <channeltype> can be auto, general, party, or raid).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh lowprofile <mode> (toggles the low profile feature of AB Helper. Replace <mode> with the following: off, mode1, or mode2).");
	DEFAULT_CHAT_FRAME:AddMessage("/abh user <user statement group> <message> (In place of <user statement group> put a valid group name, in place of <message> place anything you want).");
	DEFAULT_CHAT_FRAME:AddMessage("Valid user statement groups are: farm1 - farm8, mill1 - mill8, smit1 - smit8, mine1 - mine8, and stab1 - stab8.");
	
end


function ABH_DEBUG(i)

	if(i == 1) then
		FarmOldClockTime = time();
		FarmTimerValue = 61;
		SetTimerColor("Farm");
		getglobal("FarmTimerFrame"):Show();
		getglobal("FarmTimerFrame2"):Show();
	elseif(i == 2) then
		MillOldClockTime = time();
		MillTimerValue = 61;
		SetTimerColor("Mill");
		getglobal("MillTimerFrame"):Show();
		getglobal("MillTimerFrame2"):Show();

	elseif(i == 3) then
		BlacksmithOldClockTime = time();
		BlacksmithTimerValue = 61;
		SetTimerColor("Blacksmith");
		getglobal("BlacksmithTimerFrame"):Show();
		getglobal("BlacksmithTimerFrame2"):Show();
	elseif(i == 4) then
		MineOldClockTime = time();
		MineTimerValue = 61;
		SetTimerColor("Mine");
		getglobal("MineTimerFrame"):Show();
		getglobal("MineTimerFrame2"):Show();
	elseif(i == 5) then
		StablesOldClockTime = time();
		StablesTimerValue = 61;
		SetTimerColor("Stables");
		getglobal("StablesTimerFrame"):Show();
		getglobal("StablesTimerFrame2"):Show();
	end
end


--DEBUG
function ABH_Resource(i, num)
	local name, description, textureIndex, x, y;

	name, description, textureIndex, x, y = GetMapLandmarkInfo(i);
	
	--if(name == nil) then
	--	DEFAULT_CHAT_FRAME:AddMessage("DEBUG: nil");
	--	return;
	--end

	if(num == 1) then	
		DEFAULT_CHAT_FRAME:AddMessage(name);
	elseif(num == 2) then
		DEFAULT_CHAT_FRAME:AddMessage(description);
	elseif(num == 3) then
		DEFAULT_CHAT_FRAME:AddMessage(textureIndex);
	elseif(num == 4) then
		DEFAULT_CHAT_FRAME:AddMessage(x.." "..y);
	end
end


function ABH_PopupVanishTimer(arg1)
	
	if ( ABH_IsInWindow == nil ) then
		
		ABH_Popup_Counter = ABH_Popup_Counter + arg1;

		if(ABH_Popup_Counter >= 2) then
			ABHPickNumberPopup:Hide();
			--ABHUserStatementPopup:Hide();

			ABH_Popup_Counter = 0;
		end
	else
		ABH_Popup_Counter = 0;
	end
end


function ABH_UserStatementPopupVanishTimer(arg1)
	
	if ( ABH_IsInUserWindow == nil ) then
		
		ABH_UserStatementPopup_Counter = ABH_UserStatementPopup_Counter + arg1;

		if(ABH_UserStatementPopup_Counter >= 2) then
			--ABHPickNumberPopup:Hide();
			ABHUserStatementPopup:Hide();

			ABH_UserStatementPopup_Counter = 0;
		end
	else
		ABH_UserStatementPopup_Counter = 0;
	end
end


function ABH_OnUpdate(arg1)
	local CurrentTime = 0;

	--[[
	ABH_RaidResetCounter = ABH_RaidResetCounter + arg1;

	if ( ABH_RaidResetCounter >= 20 ) then
		ABH_InParty = 1;
		ABH_RaidResetCounter = 0;
		
		--ABHelperConvertRaidButton2:SetText("1");
	end
	]]

	ABHCounter = ABHCounter + arg1;

	if(ABHCounter >= 1) then

		CurrentTime = time();

		if(FarmTimerValue >= 0) then

			FarmTimerValue = FarmTimerValue - (CurrentTime - FarmOldClockTime);
			
			if(FarmTimerValue < 10) then
				getglobal("FarmTimerText"):SetTextColor(1, 0, 0);
				getglobal("FarmTimerText2"):SetTextColor(1, 0, 0);
			end

			if(FarmTimerValue >= 0) then
				getglobal("FarmTimerText"):SetText(date("%M:%S ", FarmTimerValue));
				getglobal("FarmTimerText2"):SetText(date("%M:%S ", FarmTimerValue));
			else
				getglobal("FarmTimerFrame"):Hide();
				getglobal("FarmTimerFrame2"):Hide();
			end
			
			FarmOldClockTime = CurrentTime;
			
		end
		
		if(MillTimerValue >= 0) then
				
			
			MillTimerValue = MillTimerValue - (CurrentTime - MillOldClockTime);
			
			if(MillTimerValue < 10) then
				getglobal("MillTimerText"):SetTextColor(1, 0, 0);
				getglobal("MillTimerText2"):SetTextColor(1, 0, 0);
			end

			if(MillTimerValue >= 0) then
				getglobal("MillTimerText"):SetText(date("%M:%S ", MillTimerValue));
				getglobal("MillTimerText2"):SetText(date("%M:%S ", MillTimerValue));
			else
				getglobal("MillTimerFrame"):Hide();
				getglobal("MillTimerFrame2"):Hide();
			end

			MillOldClockTime = CurrentTime;

		end

		if(BlacksmithTimerValue >= 0) then
			BlacksmithTimerValue = BlacksmithTimerValue - (CurrentTime - BlacksmithOldClockTime);
			
			if(BlacksmithTimerValue < 10) then
				getglobal("BlacksmithTimerText"):SetTextColor(1, 0, 0);
				getglobal("BlacksmithTimerText2"):SetTextColor(1, 0, 0);
			end

			if(BlacksmithTimerValue >= 0) then
				getglobal("BlacksmithTimerText"):SetText(date("%M:%S ", BlacksmithTimerValue));
				getglobal("BlacksmithTimerText2"):SetText(date("%M:%S ", BlacksmithTimerValue));
			else
				getglobal("BlacksmithTimerFrame"):Hide();
				getglobal("BlacksmithTimerFrame2"):Hide();
			end
			BlacksmithOldClockTime = CurrentTime;

		end

		if(MineTimerValue >= 0) then
			MineTimerValue = MineTimerValue - (CurrentTime - MineOldClockTime);
			
			if(MineTimerValue < 10) then
				getglobal("MineTimerText"):SetTextColor(1, 0, 0);
				getglobal("MineTimerText2"):SetTextColor(1, 0, 0);
			end

			if(MineTimerValue >= 0) then
				getglobal("MineTimerText"):SetText(date("%M:%S ", MineTimerValue));
				getglobal("MineTimerText2"):SetText(date("%M:%S ", MineTimerValue));
			else
				getglobal("MineTimerFrame"):Hide();
				getglobal("MineTimerFrame2"):Hide();
			end
			MineOldClockTime = CurrentTime;

		end

		if(StablesTimerValue >= 0) then
			StablesTimerValue = StablesTimerValue - (CurrentTime - StablesOldClockTime);
			
			if(StablesTimerValue < 10) then
				getglobal("StablesTimerText"):SetTextColor(1, 0, 0);
				getglobal("StablesTimerText2"):SetTextColor(1, 0, 0);
			end

			if(StablesTimerValue >= 0) then
				getglobal("StablesTimerText"):SetText(date("%M:%S ", StablesTimerValue));
				getglobal("StablesTimerText2"):SetText(date("%M:%S ", StablesTimerValue));
			else
				getglobal("StablesTimerFrame"):Hide();
				getglobal("StablesTimerFrame2"):Hide();
			end
			StablesOldClockTime = CurrentTime;

		end

		ABHCounter = 0;
	end
end


--LOCALIZE THIS
function ABHelper_SlashHandler(cmd)
	
	local args = {};
	local counter = 0;
	local i, w;
	local status;
	local TmpStr = {};
	TmpStr = "";

	for w in string.gmatch(cmd, "%w+") do
		counter = counter + 1;
		args[counter] = w;
	end

	if (args[1] == "show" and args[2] == nil) then
		ABH_ShowHelper();
	elseif (args[1] == "hide" and args[2] == nil) then
		ABHelperFrame:Hide();
		ABHelperFrameHorizontal:Hide();
	elseif (args[1] == "on" and args[2] == nil) then
		ABHelperOptions["Disabled"] = nil;
		DEFAULT_CHAT_FRAME:AddMessage("AB Helper enabled.");
	elseif (args[1] == "off" and args[2] == nil) then
		ABHelperOptions["Disabled"] = 1;
		DEFAULT_CHAT_FRAME:AddMessage("AB Helper disabled.");
	elseif (args[1] == "channel") then

		if(args[2] == "auto") then
			ABHelperOptions["Channel"] = nil;
		elseif(args[2] == "general") then
			ABHelperOptions["Channel"] = "general";
		elseif(args[2] == "party") then
			ABHelperOptions["Channel"] = "party";
		elseif(args[2] == "raid") then
			ABHelperOptions["Channel"] = "raid";
		elseif(args[2] == nil) then
			DEFAULT_CHAT_FRAME:AddMessage("Current AB Helper channel is: "..ABHelperOptions["Channel"]);
		end

	elseif (args[1] == "assaultmessage") then
		if(args[2] ~= nil) then
			TmpStr = strsub(cmd, 16);
		
			ABHelperOptions["AssaultText"] = TmpStr;
		end

		DEFAULT_CHAT_FRAME:AddMessage("Current assault text: "..ABHelperOptions["AssaultText"].." mine");

	elseif (args[1] == "incomingmessage") then
		if(args[2] ~= nil) then
			TmpStr = strsub(cmd, 17);

			ABHelperOptions["IncomingText"] = TmpStr;
		end

		DEFAULT_CHAT_FRAME:AddMessage("Current incoming text: "..ABHelperOptions["IncomingText"].." mine");
	
	elseif (args[1] == "resetposition" ) then
		ABH_ResetPosition();
	elseif (args[1] == "lowprofile" ) then
		if (args[2] == "off") then
			ABHelperOptions["LowProfile"] = nil;
			ABH_Vertical_Mode();
			ABHelper_Hide(0);
		elseif (args[2] == "mode1") then
			ABHelperOptions["LowProfile"] = 1;
			ABH_Vertical_Mode();
			ABHelper_Hide(1);
		elseif (args[2] == "mode2") then
			ABHelperOptions["LowProfile"] = 2;
			ABH_Horizontal_Mode();
		else
			DEFAULT_CHAT_FRAME:AddMessage("Valid parameters to lowprofile are: off, mode1, or mode2.");
		end
		
	elseif (args[1] == "user" and args[2] ~= nil) then

		TmpStr = strsub(cmd, 11);

		if     (args[2] == "farm1") then
			ABHelperOptions["UserStatements"]["Farm1"] = TmpStr;
		elseif (args[2] == "farm2") then
			ABHelperOptions["UserStatements"]["Farm2"] = TmpStr;
		elseif (args[2] == "farm3") then
			ABHelperOptions["UserStatements"]["Farm3"] = TmpStr;
		elseif (args[2] == "farm4") then
			ABHelperOptions["UserStatements"]["Farm4"] = TmpStr;
		elseif (args[2] == "farm5") then
			ABHelperOptions["UserStatements"]["Farm5"] = TmpStr;
		elseif (args[2] == "farm6") then
			ABHelperOptions["UserStatements"]["Farm6"] = TmpStr;
		elseif (args[2] == "farm7") then
			ABHelperOptions["UserStatements"]["Farm7"] = TmpStr;
		elseif (args[2] == "farm8") then
			ABHelperOptions["UserStatements"]["Farm8"] = TmpStr;

		elseif (args[2] == "mill1") then
			ABHelperOptions["UserStatements"]["Mill1"] = TmpStr;
		elseif (args[2] == "mill2") then
			ABHelperOptions["UserStatements"]["Mill2"] = TmpStr;
		elseif (args[2] == "mill3") then
			ABHelperOptions["UserStatements"]["Mill3"] = TmpStr;
		elseif (args[2] == "mill4") then
			ABHelperOptions["UserStatements"]["Mill4"] = TmpStr;
		elseif (args[2] == "mill5") then
			ABHelperOptions["UserStatements"]["Mill5"] = TmpStr;
		elseif (args[2] == "mill6") then
			ABHelperOptions["UserStatements"]["Mill6"] = TmpStr;
		elseif (args[2] == "mill7") then
			ABHelperOptions["UserStatements"]["Mill7"] = TmpStr;
		elseif (args[2] == "mill8") then
			ABHelperOptions["UserStatements"]["Mill8"] = TmpStr;
		
		elseif (args[2] == "smit1") then
			ABHelperOptions["UserStatements"]["Smith1"] = TmpStr;
		elseif (args[2] == "smit2") then
			ABHelperOptions["UserStatements"]["Smith2"] = TmpStr;
		elseif (args[2] == "smit3") then
			ABHelperOptions["UserStatements"]["Smith3"] = TmpStr;
		elseif (args[2] == "smit4") then
			ABHelperOptions["UserStatements"]["Smith4"] = TmpStr;
		elseif (args[2] == "smit5") then
			ABHelperOptions["UserStatements"]["Smith5"] = TmpStr;
		elseif (args[2] == "smit6") then
			ABHelperOptions["UserStatements"]["Smith6"] = TmpStr;
		elseif (args[2] == "smit7") then
			ABHelperOptions["UserStatements"]["Smith7"] = TmpStr;
		elseif (args[2] == "smit8") then
			ABHelperOptions["UserStatements"]["Smith8"] = TmpStr;

		elseif (args[2] == "mine1") then
			ABHelperOptions["UserStatements"]["Mine1"] = TmpStr;
		elseif (args[2] == "mine2") then
			ABHelperOptions["UserStatements"]["Mine2"] = TmpStr;
		elseif (args[2] == "mine3") then
			ABHelperOptions["UserStatements"]["Mine3"] = TmpStr;
		elseif (args[2] == "mine4") then
			ABHelperOptions["UserStatements"]["Mine4"] = TmpStr;
		elseif (args[2] == "mine5") then
			ABHelperOptions["UserStatements"]["Mine5"] = TmpStr;
		elseif (args[2] == "mine6") then
			ABHelperOptions["UserStatements"]["Mine6"] = TmpStr;
		elseif (args[2] == "mine7") then
			ABHelperOptions["UserStatements"]["Mine7"] = TmpStr;
		elseif (args[2] == "mine8") then
			ABHelperOptions["UserStatements"]["Mine8"] = TmpStr;

		elseif (args[2] == "stab1") then
			ABHelperOptions["UserStatements"]["Stables1"] = TmpStr;
		elseif (args[2] == "stab2") then
			ABHelperOptions["UserStatements"]["Stables2"] = TmpStr;
		elseif (args[2] == "stab3") then
			ABHelperOptions["UserStatements"]["Stables3"] = TmpStr;
		elseif (args[2] == "stab4") then
			ABHelperOptions["UserStatements"]["Stables4"] = TmpStr;
		elseif (args[2] == "stab5") then
			ABHelperOptions["UserStatements"]["Stables5"] = TmpStr;
		elseif (args[2] == "stab6") then
			ABHelperOptions["UserStatements"]["Stables6"] = TmpStr;
		elseif (args[2] == "stab7") then
			ABHelperOptions["UserStatements"]["Stables7"] = TmpStr;
		elseif (args[2] == "stab8") then
			ABHelperOptions["UserStatements"]["Stables8"] = TmpStr;	
		elseif (args[2] == "reset") then
			ABH_Reset_UserStatements();
		else
			DEFAULT_CHAT_FRAME:AddMessage("Incorrect user statement type.");
		end
	elseif (args[1] == "user" and args[2] == nil) then
		DEFAULT_CHAT_FRAME:AddMessage("Valid user statement groups are: farm1 - farm8, mill1 - mill8, smit1 - smit8, mine1 - mine8, and stab1 - stab8.");
	elseif (args[1] == "autoinvite") then
		if ( args[2] == "on" ) then
			ABHelperOptions["AutoInvite"] = 1;
		elseif ( args[2] == "off" ) then
			ABHelperOptions["AutoInvite"] = nil;
		end

		if ( ABHelperOptions["AutoInvite"] ) then
			DEFAULT_CHAT_FRAME:AddMessage("Autoinvite on.");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Autoinvite off.");
		end

	elseif (args[1] == "autoinviteword") then
		if ( args[2] ~= nil) then
			ABHelperOptions["AutoInviteKeyword"] = strsub(cmd, 16);
		end
		
		DEFAULT_CHAT_FRAME:AddMessage("Autoinvite keyword: "..ABHelperOptions["AutoInviteKeyword"]);
	elseif (args[1] == "inviteall" and args[2] == nil) then
		ABH_InviteAll();
		DEFAULT_CHAT_FRAME:AddMessage("Autoinviting everyone.");
	else
		ABHelper_Help();
	end
end


function ABHPopupButtonClick(num)
	ABH_Raid_Warning(ABH_PopupTitle:GetText(), num);
	ABHPickNumberPopup:Hide();
end


function ABH_Show_PopUp()

	if (ABHPickNumberPopup:IsVisible()) then
		ABHPickNumberPopup:Hide();
	else
		
		 ABHPickNumberPopup:Show();
	end
end


function ABH_Show_UserStatementPopUp()
	
	if (ABHUserStatementPopup:IsVisible()) then
		ABHUserStatementPopup:Hide();
	else
		
		 ABHUserStatementPopup:Show();
	end
end


function ABHButtonOnClick(button)

	if ( IsShiftKeyDown() ) then
		ABH_Popup_Counter = 0;
		ABHUserStatementPopup:Hide();

		if (ABH_PopupTitle:GetText() ~= button) then
			ABH_PopupTitle:SetText(button);
			ABHPickNumberPopup:Show();
		else
			ABH_Show_PopUp();
		end

		if (button == TRANSLATION_FARM) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHPickNumberPopup:SetPoint("TOPLEFT", 36, -100);
			else
				ABHPickNumberPopup:SetPoint("TOPLEFT", 130, -50);
			end
		elseif (button == TRANSLATION_LUMBERMILL) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHPickNumberPopup:SetPoint("TOPLEFT", 136, -100);
			else
				ABHPickNumberPopup:SetPoint("TOPLEFT", 130, -84);
			end
		elseif (button == TRANSLATION_BLACKSMITH) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHPickNumberPopup:SetPoint("TOPLEFT", 236, -100);
			else
				ABHPickNumberPopup:SetPoint("TOPLEFT", 130, -118);
			end
		elseif (button == TRANSLATION_GOLDMINE) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHPickNumberPopup:SetPoint("TOPLEFT", 336, -100);
			else
				ABHPickNumberPopup:SetPoint("TOPLEFT", 130, -150);
			end
		elseif (button == TRANSLATION_STABLES) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHPickNumberPopup:SetPoint("TOPLEFT", 436, -100);
			else
				ABHPickNumberPopup:SetPoint("TOPLEFT", 130, -180);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG");
		end

	elseif ( IsControlKeyDown() ) then
		ABH_UserStatementPopup_Counter = 0;
		ABHPickNumberPopup:Hide();
		ABH_Populate_UserStatements(button);

		if (ABH_UserStatementPopupTitle:GetText() ~= button) then
			ABH_UserStatementPopupTitle:SetText(button);
			ABHUserStatementPopup:Show();
		else
			ABH_Show_UserStatementPopUp();
		end

		if (button == TRANSLATION_FARM) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHUserStatementPopup:SetPoint("TOPLEFT", 16, -100);
			else
				ABHUserStatementPopup:SetPoint("TOPLEFT", 130, -50);
			end
		elseif (button == TRANSLATION_LUMBERMILL) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHUserStatementPopup:SetPoint("TOPLEFT", 116, -100);
			else
				ABHUserStatementPopup:SetPoint("TOPLEFT", 130, -84);
			end
		elseif (button == TRANSLATION_BLACKSMITH) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHUserStatementPopup:SetPoint("TOPLEFT", 216, -100);
			else
				ABHUserStatementPopup:SetPoint("TOPLEFT", 130, -118);
			end
		elseif (button == TRANSLATION_GOLDMINE) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHUserStatementPopup:SetPoint("TOPLEFT", 316, -100);
			else
				ABHUserStatementPopup:SetPoint("TOPLEFT", 130, -150);
			end
		elseif (button == TRANSLATION_STABLES) then
			if (ABHelperOptions["LowProfile"] == 2) then
				ABHUserStatementPopup:SetPoint("TOPLEFT", 416, -100);
			else
				ABHUserStatementPopup:SetPoint("TOPLEFT", 130, -180);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("DEBUG");
		end

	else
		ABH_Raid_Warning(button);
	end
end